require( "scene1" )
require( "scene2" )
require( "scene3" )

SceneManager = {}
SceneManager.new = function ()
    
    local this = {}
    

    --=========================================================
    -- 初期設定
    --=========================================================
    this.init = function ( self )
    
        self.sceneList = {
            scene1 = Scene1.new(),
            scene2 = Scene2.new(),
            scene3 = Scene3.new(),
        }
        -- 最初のシーン
        self.currentScene = "scene1"
        self.sceneList[this.currentScene]:enter()
    end
    

    
    

    --=========================================================
    -- 更新
    --=========================================================
    this.update = function(self, dt)
        
        self.sceneList [ self.currentScene ]:update(dt)
        
    end
    
    --=========================================================
    -- 描画
    --=========================================================
    this.draw = function(self)
        
        love.graphics.clear(1,1,1,1)
        love.graphics.setColor(1,1,1,1)
        
        self.sceneList [ self.currentScene ]:draw()
        
    end
    

    
    
    

    --=========================================================
    -- マウス入力受付
    --=========================================================
    this.mousereleased = function ( self, x, y, buttonNum )
        
        if ( this.sceneList[this.currentScene].mousereleased ) then
            self.sceneList[this.currentScene]:mousereleased ( x, y, buttonNum )
        end
        
    end
    


    

    --=========================================================
    -- 次のシーンへ遷移
    --=========================================================
    this.changeScene = function ( self, nextSceneName )
        
        self.sceneList [ self.currentScene ]:leave()
        self.sceneList [ nextSceneName ]:enter()
        
        self.currentScene = nextSceneName
    end
    

    return this
end
